#ifndef _PIKEDEF_H
#define _PIKEDEF_H

#if 0
#define ONBOOT_UPDATE		26


/******************DHCP Configuration******************/
#define ADI_DHCPD_STOP		1
#define ADI_DHCPD_START		2

#define ADI_SUB_CONFIG		3
#define ADI_HOST_CONFIG		4
#define ADI_LEASE_CONFIG	5
#define ADI_IFACE_CONFIG	6

/*Subnet Configuration*/
#define ADI_SUBNET_ADD		7	
#define ADI_SUBNET_DEL		8  
#define ADI_SUBNET_LIST		9

/*Host Configuration*/
#define ADI_HOST_ADD		10	
#define ADI_HOST_DEL		11	
#define ADI_HOST_LIST		12	

/*Lease Configuration*/
#define ADI_LEASE_DEL		13
#define ADI_LEASE_LIST		14


/******************DHCP Relay Configuration******************/
#define ADI_DHRELAY_STOP		1
#define ADI_DHRELAY_START		2



/******************DHCP Clien Configuration******************/
#define ADI_DHCLIENT_STOP		1
#define ADI_DHCLIENT_START		2
#define ADI_DHCLIENT_RESTART		3


/******************DHCP Clien Configuration******************/
#define ADI_BOOTPCLIENT_STOP		4	
#define ADI_BOOTPCLIENT_START		5
#define ADI_BOOTPCLIENT_RESTART		6


/**************************Rarpd Configuration*******************/
#define ADI_RARPD_STOP		1
#define ADI_RARPD_START		2
#define ADI_RARPD_ADD		3
#define ADI_RARPD_DEL		4
#define ADI_RARPD_LIST		5
#define ADI_RARPD_STOP_ALL	6
#define ADI_RARPD_START_ALL	7

/************************DNS Client Configuration******************/
#define ADI_DNSC_PRIMARY	1
#define ADI_DNSC_SECONDARY  	2
#define ADI_DNSC_DOMAIN		3
#define ADI_DNSC_LIST		4

/**********************RIPD Configuration *******************/
#define ADI_RIPD_STOP		1
#define ADI_RIPD_START		2
#define ADI_RIPD_VERSION	3
#define ADI_RIPD_VERSION_DISP	4	

/*********************8DNS Relay Configuration***************/
#define ADI_DNRD_SINGLE_START	1
#define ADI_DNRD_SINGLE_STOP	2
#define ADI_DNRD_DOUBLE_START	3
#define ADI_DNRD_DOUBLE_STOP	4
#define ADI_DNRD_START		5
#define ADI_DNRD_STOP		6
#endif
/*******************Snmp Configuration************************8*/
#define ADI_SNMP_DSET		0X1
#define ADI_SNMP_CSET		0x2
#define ADI_SNMP_LSET		0x4
#define ADI_SNMP_ISET		0x8
#define ADI_SNMP_TSET		0x10
#define ADI_SNMP_RSET		0x20
#define ADI_SNMP_M1SET		0x40
#define ADI_SNMP_M2SET		0x80
#define ADI_SNMP_START		256
#define ADI_SNMP_LIST		257
#define ADI_SNMP_SHUTDOWN	258
#define ADI_SNMP_SET		259
#define ADI_PATH_SNMPD_EXE		"/bin/snmpd"
#define ADI_PATH_SNMPD_PID		"/etc/snmpd.pid"
#define ADI_PATH_SNMPD_CONF		"/etc/snmpd.conf"

#if 0
#define ADI_FAILURE     	-1
#define ADI_SUCCESS		1

#define ADI_TRUE		1
#define ADI_FALSE		0

typedef struct dnsClientStruct
{
	char nameServer1[16];
	char nameServer2[16];
	char domain[65];
}DnsClientType;

/***************************PID MACROS************************/
#define ADI_PATH_DHCPD_PID		"/var/dhcpd.pid"
#define ADI_PATH_DHCLIENT_PID		"/var/dhclient.pid"
#define ADI_PATH_DHCRELAY_PID		"/var/dhcrelay.pid"
#define ADI_PATH_SNMPD_PID		"/var/snmpd.pid"
#define ADI_PATH_RIPD_PID		"/var/ripd.pid"
#define ADI_PATH_ZEBRAD_PID		"/var/zebrad.pid"
#define ADI_PATH_FTPD_PID		"/var/ftpd.pid"
#define ADI_PATH_DNSMASQ_PID		"/var/dnsmasq.pid"
#define ADI_PATH_HTTPD_PID		"/var/httpd.pid"
#define ADI_PATH_RARPD_PID		"/var/rarpd"
/***************************PID MACROS************************/


/**************************CONF MACROS***********************/
#define ADI_PATH_DHCPD_LOC_CONF		"/var/dhcpdloc.conf"
#define ADI_PATH_DHCPD_LOC_LEASE	"/var/dhcpdloc.leases"
#define ADI_PATH_DHCRELAY_CONF		"/var/dhcrelay.conf"
#define ADI_PATH_DHCLIENT_CONF		"/var/dhclient.conf"
#define ADI_PATH_SNMPD_CONF		"/var/snmpd.conf"
#define ADI_PATH_RIPD_CONF		"/var/ripd.conf"
#define ADI_PATH_DNSMASQ_CONF		"/var/dnsmasq.conf"
#define ADI_PATH_RARPD_LOC_CONF		"/var/rarpd.conf"


#define ADI_PATH_DHCPD_LEASE		"/var/adidhcpd.leases"
#define ADI_PATH_DHCPD_CONF		"/var/dhcpd.conf"
#define ADI_PATH_RARPD_CONF		"/var/ethers"
#define ADI_PATH_RESOLV_CONF		"/var/resolv.conf"
#define ADI_PATH_EMAC_CONF		"/var/emaclink.conf"

/**************************CONF MACROS***********************/

/************************EXE PATH MACROS******************/

#define ADI_PATH_DHCPD_EXE		"/bin/dhcpd"
#define ADI_PATH_DHCLIENT_EXE		"/bin/dhclient"
#define ADI_PATH_DHCRELAY_EXE		"/bin/dhcrelay"
#define ADI_PATH_SNMPD_EXE		"/bin/snmpd"
#define ADI_PATH_RIPD_EXE		"/bin/rip"
#define ADI_PATH_RARPD_EXE		"/bin/rarpd"
#define ADI_PATH_DNSMASQ_EXE		"/bin/dnsmasq"


typedef struct dnsRelayConfigStruct
{
	char server1[16];
	char server2[16];
}DnsRelayConfigType;

#endif
#endif
