
/**************************************************************
$Workfile:   map16port.c  $
***************************************************************
**
** FIRMWARE, Copyright (C) 2000-2002
** Ikanos Communications, Fremont, CA
** All rights reserved.
**
** The information and contents of this file are the
** proprietary information of Ikanos Communication and may not
** be disclosed or used without the formal written approval of
** Ikanos Communication
**
$Revision: 1.1 $
$Date: 2006/10/16 04:34:49 $
***************************************************************/
#include "ipos.h"
#include "portmap.h"
#include "appconfig.h"
#include "dapi_define.h"

#define TWO_PORTS_PLAN	(1 << BP2_998_3) | (1 << BP26_CH1_3) | \
                        (1 << BP3_998_4) | (1 << BP27_CH1_4) | \
												(1 << BP7_MXU_3) | (1 << BP8_MXU_2) | \
												(1 << BP14_MXU_3) | (1 << BP15_MXU_3) | \
												(1 << BP16_997_4B_4P) | (1 << BP17_998_138_4400) | \
												(1 << BP18_997_138_4400) | (1<<BP19_997_32_4400) | \
												(1 << BP21_997_138_4400_opBand) | (1 << BP22_998_138_4400_opBand) | \
												(1 << BP23_998_138_16000) | (1 << BP24_998_3B_8KHZ) | \
												(1 << BP25_998_138_17600)

#define FOUR_PORTS_PLAN	(1 << BP2_998_3) | (1 << BP26_CH1_3) | \
												(1 << BP7_MXU_3) | (1 << BP8_MXU_2) | \
												(1 << BP14_MXU_3) | (1 << BP15_MXU_3) | \
												(1 << BP16_997_4B_4P) | (1 << BP17_998_138_4400) | \
												(1 << BP18_997_138_4400) | (1<<BP19_997_32_4400) | \
												(1 << BP21_997_138_4400_opBand) | (1 << BP22_998_138_4400_opBand) |\
												(1 << BP24_998_3B_8KHZ)
												
#define EIGHT_PORTS_PLAN	(1 << BP8_MXU_2) | (1 << BP17_998_138_4400)	| \
							(1 << BP18_997_138_4400) | (1<<BP19_997_32_4400) | \
							(1 << BP21_997_138_4400_opBand) | (1 << BP22_998_138_4400_opBand)


sys_port_mapping 	sysPortMap[IPOS_MAX_PORTS] =
{											              /*	8 Port Reference board	  */
#ifdef SIM4P
	{1, 0, 8, 0,{1, 1,}, TWO_PORTS_PLAN},
	{2, 1, 9, 1,{2, 1,}, FOUR_PORTS_PLAN},
	{3, 2, 12,4,{5, 1,}, TWO_PORTS_PLAN},
	{4, 3, 13,5,{6, 1,}, FOUR_PORTS_PLAN},
#elif defined(SIM2P)
	{1, 0, 8, 0,{1, 1,}, TWO_PORTS_PLAN},
	{2, 2, 12,4,{5, 1,}, TWO_PORTS_PLAN},
#else
	{1,  0,  16, 0, {1, 1,}, TWO_PORTS_PLAN},				  /* lineNum1	        */
	{2,  1,  17, 1, {2, 1,}, FOUR_PORTS_PLAN},				/* lineNum2	        */
	{3,  2,  18, 2, {3, 1,}, EIGHT_PORTS_PLAN},				/* lineNum3:        */
	{4,  3,  19, 3, {4, 1,}, EIGHT_PORTS_PLAN},				/* lineNum4,        */
	{5,  4,  20, 4, {5, 1,}, TWO_PORTS_PLAN},				  /* lineNum5	        */
	{6,  5,  21, 5, {6, 1,}, (FOUR_PORTS_PLAN) & (~(1 << BP24_998_3B_8KHZ))},
                         /* lineNum6: BP24_998_3B_8KHZbandplan supports only 3 ports/BME */
	{7,  6,  22, 6, {7, 1,}, EIGHT_PORTS_PLAN},				/* lineNum7:        */
	{8,  7,  23, 7, {8, 1,}, EIGHT_PORTS_PLAN},				/* lineNum8,        */
	{9,  8,  24, 8, {1, 2,}, TWO_PORTS_PLAN},				  /* lineNum9	        */
	{10, 9,  25, 9, {2, 2,}, FOUR_PORTS_PLAN},				/* lineNum10        */
	{11, 10, 26, 10,{3, 2,}, EIGHT_PORTS_PLAN},				/* lineNum11        */
	{12, 11, 27, 11,{4, 2,}, EIGHT_PORTS_PLAN},				/* lineNum12        */
	{13, 12, 28, 12,{5, 2,}, TWO_PORTS_PLAN},				  /* lineNum13        */
	{14, 13, 29, 13,{6, 2,}, (FOUR_PORTS_PLAN) & (~(1 << BP24_998_3B_8KHZ))},
			/* lineNum14: BP24_998_3B_8KHZbandplan supports only 3 ports/BME */
	{15, 14, 30, 14,{7, 2,}, EIGHT_PORTS_PLAN},				/* lineNum15        */
	{16, 15, 31, 15,{8, 2,}, EIGHT_PORTS_PLAN},				/* lineNum16        */


#endif
};
	



