
/**************************************************************
$Workfile:   map8portco2.c  $
***************************************************************
**
** FIRMWARE, Copyright (C) 2000-2002
** Ikanos Communications, Fremont, CA
** All rights reserved.
**
** The information and contents of this file are the
** proprietary information of Ikanos Communication and may not
** be disclosed or used without the formal written approval of
** Ikanos Communication
**
$Revision: 1.1 $
$Date: 2006/10/16 04:34:49 $
***************************************************************/
#include "ipos.h"
#include "portmap.h"
#include "appconfig.h"
#include "dapi_define.h"

#define FOUR_PORTS_PLAN	(\
	(1 << BP2_998_3) | (1 << BP3_998_4) | \
    (1 << BP26_CH1_3) | (1 << BP27_CH1_4) | \
	(1 << BP23_998_138_16000) | (1 << BP7_MXU_3) | \
	(1 << BP8_MXU_2) | (1 << BP14_MXU_3) | \
	(1 << BP15_MXU_3) | (1 << BP16_997_4B_4P) | \
	(1 << BP17_998_138_4400) | (1 << BP18_997_138_4400) | \
	(1<<BP19_997_32_4400) | (1 << BP21_997_138_4400_opBand) | \
	(1 << BP22_998_138_4400_opBand) | (1 << BP24_998_3B_8KHZ) | \
	(1 << BP25_998_138_17600))

#define EIGHT_PORTS_PLAN (\
	(1 << BP8_MXU_2) | (1 << BP17_998_138_4400)	| \
   (1 << BP18_997_138_4400) | (1<<BP19_997_32_4400) | \
   (1 << BP21_997_138_4400_opBand) | (1 << BP22_998_138_4400_opBand) | \
   (1 << BP24_998_3B_8KHZ) )

#ifdef CO_20_REFBOARD_2BME
/*  8 Port CO-2.0 Reference board  with 2 BMEs   */
sys_port_mapping    sysPortMap[IPOS_MAX_PORTS] = {
    {1, 0, 8, 0,{1, 1,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {2, 1, 9, 1,{3, 1,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {3, 2, 10,2,{5, 1,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {4, 3, 11,3,{7, 1,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {5, 4, 12,4,{1, 2,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {6, 5, 13,5,{3, 2,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {7, 6, 14,6,{5, 2,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
    {8, 7, 15,7,{7, 2,}, FOUR_PORTS_PLAN | EIGHT_PORTS_PLAN },
};
#else
/*	8 Port CO-2.0 Reference board	  */
sys_port_mapping 	sysPortMap[IPOS_MAX_PORTS] = {
	{1, 0, 8, 0,{1, 1,}, FOUR_PORTS_PLAN  },
#ifndef CO_20_1Port_CO
	{2, 1, 9, 1,{2, 1,}, EIGHT_PORTS_PLAN },
	{3, 2, 10,2,{3, 1,}, FOUR_PORTS_PLAN  },
	{4, 3, 11,3,{4, 1,}, EIGHT_PORTS_PLAN },
	{5, 4, 12,4,{5, 1,}, FOUR_PORTS_PLAN  },
    {6, 5, 13,5,{6, 1,}, EIGHT_PORTS_PLAN },
	{7, 6, 14,6,{7, 1,}, FOUR_PORTS_PLAN  },
	{8, 7, 15,7,{8, 1,}, EIGHT_PORTS_PLAN },
#endif
};
#endif



