#ifndef	OAMPDEFH
#define	OAMPDEFH
/**************************************************************
$Workfile:   oampdef.h  $
***************************************************************
**
** FIRMWARE, Copyright (C) 2000-2002
** Ikanos Communications, Fremont, CA
** All rights reserved.
**
** The information and contents of this file are the
** proprietary information of Ikanos Communication and may not
** be disclosed or used without the formal written approval of
** Ikanos Communication
**
$Revision: 1.1 $
$Date: 2006/10/16 04:34:50 $
***************************************************************/



typedef	enum
{
	uIDLE	=0x00,						/* BME idle	*/
    uREADY,
	uDOWN	=0x40,				 		/* BME Down	*/
	uRUN	=0x80				   		/* BME RUN	*/
} eoamp_bme_state;


typedef	enum
{

	uENABLE  		=0x01, 	   			/* port provisioned	*/
	uACTIVATING		=0x02,			  	/* port under activation	*/
	uSHOWTIME		=0x03, 			 	/* port in Showtime		*/
    uSTOP           =0x04,              /* stop port */
    uLOOPBACK       =0x05,              /* loopback */
	uDISABLE		=0x0F 			  	/* port disabled	*/

} eoamp_port_state;


typedef	enum
{								   	   
	uCMD_IDLE		=0x00, 				 /* No Command out standing	*/
	uCMD_IN_PROGRESS=0x01,				 /* Non Blocking Command out standing	*/
	uCBLK_CMD_IN_PROGRESS =0x02		/* BME does not allow issue 
											new command while in this state */
} eoamp_cmd_state;


typedef	enum
{
	
	CMD_IN_PROGRESS,					/* command in progress	*/
	CMD_SUCCESS,					   	/* command success		*/
	CMD_FAILED,						  	/* command failed		*/
	
		
	eBME_START,							/* BME start completed	*/
	eBME_RESTART_INPROGRESS,            /* BME restart in progress	*/
	eBME_RESTART_COMPLETE,              /* BME restart completed	*/
	eBME_RESTART_FAILED,				/* BME restart failed	*/
	eSYSTEM_PROVISION,                 	/* BME provision completed	*/
	
	
	ePORT_START,			   			/* port started */ 		
	ePORT_START_COMPLETE,				/* port start completed	*/	
	ePORT_STOP,                         /* port stop completed	*/
	ePORT_INSTANTIATE,		 			/* port instantiate completed	*/
	ePORT_PROVISION,			   		/* port provision completed	*/
	ePORT_DESTROY,				 		/* port destroy completed	*/
	ePORT_RESET,				 		/* port reset completed	*/
	ePORT_PPREPORT_ENABLE,	   			/* periodic report  completed	*/
	eEOC_EVNT,                   		/* BME provision completed	*/
	eBIT_SWAP_EVNT,                   		/* Bit Swap Event	*/
	ePORT_STATUS_BRIEF,		 			/* status brief completed	*/
    ePORT_LB_START_COMPLETE,            /* port in the loopback mode */

    eSTOP_PORT
}eoamp_event;


#endif
