#include <stdio.h>

//void ppio_write (UINT32 addr, UINT32 data) {
//  printf ("PIO write ADDR: 0x%x, DATA: 0x%x\n",addr, data);
//}

void ptm_ilv_mbup () 
{ 
  UINT32 ccr_status;
  UINT32 temp0, addr;
  UINT32 temp1, DmaSize;
  int i=0;
  int j=0;
  UINT32 mod, data;
  int cws, ncw, numch, LoopCnt;
  
  //reset_aztec ();
  //taskDelay (200);

  
  //reset_aztec ();
  //taskDelay (200);

  printf("Enter the Loop count:");
  scanf ("%d", &LoopCnt);
  printf("%d\n", LoopCnt);
  printf ("\n");

  printf("Enter the codeword size:");
  scanf ("%d", &cws);
  printf("%d\n", cws);
  printf ("\n");

  printf("Enter number of codewords per frame:");
  scanf ("%d", &ncw);
  printf("%d\n", ncw);
  printf ("\n");

  printf("Enter number of channels:");
  scanf ("%d", &numch);
  printf("%d\n", numch);
  printf ("\n");

  DmaSize = (cws * ncw * numch);
  if (!numch || !cws || !ncw || (DmaSize > 0x1fff)) 
    printf ("\t***** ERROR: NumCh/CodeWordSize/NumCodeWords is incorrect\n");
  else {
  printf ("************************************************\n");
  printf ("\tATM/ILV TC LOOP BACK TEST CONFIGURATION: \n");
  printf ("\tCodeword size -> %d\n",  cws);
  printf ("\tNumber of Codewords -> %d\n",  ncw);
  printf ("\tNumber of Channels -> %d\n",  numch);
  printf ("************************************************\n");

  //////////////////////////////////////
  // Initialize SEMAPHORE, FRM_CMD_COUNT, CRC to 0
  rmw_reg (0xe000843c, 0x0, 1);
  rmw_reg (0xe000843c, 0x0, 0);
  rmw_reg (0xe0008430, 0x0, 0);

  //////////////////////////////////////
  // load fmc I$
  load_fmc_icache_mbup ();

  //////////////////////////////////////
  // TNI Programming
  pio_write(0xe0000800, 0x80000000);        // set PTM mode 'on'

  for (j=0; j<numch; j++) {
    addr = 0xe0000a00 | (j*4);
    pio_write( addr, 0x80000000);           // tni ilv channel control (PTM mode only)
  }

  for (j=0; j<numch; j++) {
    addr = 0xe0000100 | (j*4);
    mod = (0x2000000*j) | 0x80000000;
    pio_write( addr, mod);                  // tni ilv channel port register
  }
  
  for (j=0; j<numch; j++) {
    addr = 0xe0000200 | (j*4);
    mod = (0x4000000*j) | 0x00000000;
    pio_write( addr, mod);                  // PHYs channel number register
  }

  for (j=0; j<numch; j++) {
    addr = 0xe0000400 | (j*4);
    pio_write( addr, 0x80000000);           // PHYs control register
  }
  
  //////////////////////////////////////
  // XFI Programming
  for (j=0; j<numch; j++) {
    addr = 0xe0040500 | (j*4);
    pio_write( addr, 0x00000000);           // xfifo ilv context table C (PTM Mode)
  }
  
  for (j=0; j<numch; j++) {
    addr = 0xe0040200 | (j*4);
    data = 0x19 | (0x200*j);
    pio_write( addr, data);                 // xfifo ilv context table A
  }
  //////////////////////////////////////
  // TOFT Programming
  pio_write( 0xe0048400, 0x00000005);       // tone order fifo context table

  //////////////////////////////////////
  // YFIFO Programming
  for (j=0; j<numch; j++) {
    addr = 0xe0048000 | (j*4);
    data = 0x41 | (0x1000*j);
    pio_write( addr, data);                 // yfifo ilv context table A
  }
  
  for (j=0; j<numch; j++) {
    addr = 0xe0048100 | (j*4);
    pio_write( addr, 0x00000000);           // yfifo ilv context table B
  }

  for (j=0; j<numch; j++) {
    addr = 0xe0048200 | (j*4);
    data = 0x10000 | ((cws&0xff) << 8);
    pio_write( addr, data);                 // yfifo ilv context table C
  }

  for (j=0; j<numch; j++) {
    addr = 0xe0048300 | (j*4);
    pio_write( addr, 0x00000000);           // yfifo ilv context table D
  }
   
  //////////////////////////////////////
  // Initialize SEMAPHORE, DMC_CMD_COUNT, DMC_CMD_TYPE to 0
  rmw_reg (0xe002043c, 0x0, 1);
  rmw_reg (0xe002043c, 0x0, 0);
  rmw_reg (0xe002042c, 0x0, 0);
 
  //////////////////////////////////////
  // Enable BFIFO demapper fifo
  pio_write( 0xe0060000, 0x00000003);       // demapper fifo context table

  //////////////////////////////////////
  // BFI programming
  for (j=0; j<numch; j++) {
    addr = 0xe0060300 | (j*4);
    data = 0x41 | (0x1000*j);
    pio_write( addr, data);                 // bfifo ilv context table A
  }
  
  for (j=0; j<numch; j++) {
    addr = 0xe0060400 | (j*4);
    pio_write( addr, 0x00000000);           // bfifo ilv context table B
  }

  for (j=0; j<numch; j++) {
    addr = 0xe0060500 | (j*4);
    data = 0x10000 | ((cws&0xff) << 8);
    pio_write( addr, data);                 // bfifo ilv context table C
  }

  for (j=0; j<numch; j++) {
    addr = 0xe0060600 | (j*4);
    pio_write( addr, 0x00000000);           // bfifo ilv context table D
  }

  //////////////////////////////////////
  // RNI programming
  for (j=0; j<numch; j++) {
    addr = 0xe0028100 | (j*4);
    pio_write( addr, 0x80000000);           // rni PHY control register
  }
  //////////////////////////////////////
  // CFI programming
  if (numch == 1)
      pio_write(0xe0068100, 0x0);
  else
      for (j=0; j<numch/2; j++) {
          addr = 0xe0068100 | (j*4);
          pio_write( addr, 0x0);            // even numbered PHYs bank B register
          addr = 0xe0068300 | (j*4);
          pio_write( addr, 0x0);            // odd numbered PHYs bank B register
      }
  
  if (numch == 1)
      pio_write(0xe0068400, 0x3);      
  else
      for (j=0; j<numch/2; j++) {
          addr = 0xe0068400 | (j*4);
          pio_write( addr, 0x3);            // even numbered PHYs bank C register (Drop_7E, Cell_Drop)
          addr = 0xe0068600 | (j*4);
          pio_write( addr, 0x3);            // odd numbered PHYs bank C register (Drop_7E, Cell_Drop)
      }
  
  if (numch == 1)
      pio_write(0xe0068500, 0x0);      
  else
      for (j=0; j<numch/2; j++) {
          addr = 0xe0068500 | (j*4);
          pio_write( addr, 0x0);            // even numbered PHYs bank D register
          addr = 0xe0068700 | (j*4);
          pio_write( addr, 0x0);            // odd numbered PHYs bank D register
      }

  if (numch == 1)
      pio_write(0xe0068000, 0x19);
  else
      for (j=0; j<numch/2; j++) {
          data = 0x19 | (0x400*j);
          addr = 0xe0068000 | (j*4);
          pio_write( addr, data);           // even numbered PHYs bank A register
          data = 0x1019 | (0x400*j);
          addr = 0xe0068200 | (j*4);
          pio_write( addr, data);           // odd numbered PHYs bank A register
      }
  //////////////////////////////////////
  // load dmc D$, I$
  load_dmc_icache_mbup ();

  load_dmc_dcache_mbup (numch);

  //////////////////////////////////////
  // load fmc D$
  load_fmc_dcache_mbup (numch);
  

  addr = 0xe0008440;
  for (j=0; j<numch; j++) {
    //////////// FMC commands ////////////
    // Set State
    pio_write (addr, (0x01000000 + 0x200000*j));  addr = addr + 4;
    pio_write (addr, 0x61000020);                 addr = addr + 4;

    mod = 0x10001 * j;
    //////////////////////////////////////
    // Send CodeWordSize-16 bytes from xfifo to yfifo ilv and
    // send CodeWordSize bytes from yfifo ilv to toft
    for (i=0; i<ncw; i++) {
      pio_write( addr, (0x81008300 | mod));       addr = addr + 4;
      pio_write( addr, (0x22600000 | (cws-16)));  addr = addr + 4;

      pio_write( addr, (0x83008300 | mod));       addr = addr + 4;
      pio_write( addr, (0x40010000 | cws));       addr = addr + 4;
    }

    //////////////////////////////////////////
    // Save State
    pio_write( addr, (0x00000100 + 0x20*j));      addr = addr + 4;
    pio_write( addr, 0x62000020);                 addr = addr + 4;
  }

  ///////////// DMC commands ///////////////
  addr = 0xe0020440;
  for (j=0; j<numch; j++) {
    // Set state
    pio_write( addr, (0x01000000 + 0x200000*j));  addr = addr + 4;
    pio_write( addr, 0x04080020);                 addr = addr + 4;

    mod = 0x10001 * j;
    for (i=0;i<ncw;i++) {
      // Read 0x4a bytes from demapper into bfifo_ilv
      pio_write( addr, (0x00008a00 | j));         addr = addr + 4;
      pio_write( addr, (0x40010000 | cws));       addr = addr + 4;
      // Set RSChkBtyes for next codeword
      pio_write( addr, 0x00100000);               addr = addr + 4;
      pio_write( addr, (0x40400000 | cws));       addr = addr + 4;
      // Read cws bytes from bfifo_ilv into rs_decoder
      pio_write( addr, (0x8a008c00 | mod));       addr = addr + 4;
      pio_write( addr, (0x40300000 | cws));       addr = addr + 4;
      // Read cws-16 bytes from rs_decoder into cfifo_inlv
      pio_write( addr, (0x8c008b00 | mod));       addr = addr + 4;
      pio_write( addr, (0x02a80000 | (cws-16)));  addr = addr + 4;
    }
    //////////////////////////////////////////
    // Save State
    pio_write( addr, (0x00000100 +0x20*j));       addr = addr + 4;
    pio_write( addr, 0x18080020);                 addr = addr + 4;
  }
  
  //////////////////////////////////////
  // Initialize TOFT-Demapper fifo DMA
  init_dma ();
 
  taskDelay (10);
  //////////////////////////////////////
  //enable dmc & fmc
  pio_write( 0xe0020000, 0x00010001);       // enable DMC
  pio_write( 0xe0008000, 0x00010001);       // enable FMC


//#if 0
  i = 0;
  while (i<LoopCnt) {
    // Set CMD_TYPE=DO_FRM_CMD
    rmw_reg (0xe000842c, 0x10000, 0);
    
    // Set the FMC command count & semaphore
    pio_write (0xe000843c, ((((2+ncw*2)*numch) << 16) | 0x1));
  
    // check FMC/DMC semaphore for clear
    poll_reg (0xe002043c, 0x0000ffff,0,0);
    poll_reg (0xe000843c, 0x0000ffff,0,0);

    poll_toft (DmaSize);

    // Set DMC Command type
    rmw_reg (0xe002042c, 0x10000, 0);
  
    // Set DMC command count & Semaphore
    pio_write (0xe002043c, ((((2+ncw*4)*numch) << 16) | 0x1));
    i++;
  }
//#endif
  }
}   /*end of test*/
