#ifdef CO_30_DIAGS


/************** INCLUDE FILES ****************************/
#include <stdio.h>
#include <vxWorks.h>
#include "apposmacro.h"
#include "diags_defines.h"

/************** LOCAL MACROS *****************************/

/************** GLOBAL VARIABLES *************************/

/************** EXTERN FUNCTIONS AND VARIABLES ***********/
void bmeHWReset (void);
void testPIOWrite (int BmeNum, unsigned long addr, unsigned long data);
int testPIORead1 (int BmeNum, unsigned long addr);


/************** LOCAL FUNCTION PROTOTYPES ****************/
void bup_Enable_Vbus (int bmeNum, int vbusnum);
UINT32 bup_rdAfeReg (int bmeNum, int afenum, UINT32 addr);
int bup_rdnchkAfeReg(int bmeNum, int afenum, UINT32 addr, UINT32 exp_data);
void bup_wtAfeReg (int bmeNum, int afenum, UINT32 addr, UINT32 data);
int bup_chk_afeid (int bmeNum, int afenum);

/*********************************************************/
/*            EXPORTED FUNCTION DEFINITIONS              */
/*********************************************************/

int bup_afe_reg_rw (int bmeNum)
{
	int testfail=0;
	int i=0;
	int loop_cnt=1;
	int afe_present=0;
	int afe=0;
	UINT32 dat;


#ifdef CO_20
	for (afe=0; afe<=7; afe++)
#endif
	{
		bup_Enable_Vbus (bmeNum,afe/2);
		afe_present = bup_chk_afeid (bmeNum, afe);
		i = 0;
		if (afe_present)
			while (i<loop_cnt)
			{
				dat = rand ();
				bup_wtAfeReg (bmeNum, afe, 0xf0, dat);
				testfail = bup_rdnchkAfeReg (bmeNum, afe, 0xf0, dat);
				i++;
				if (testfail)
					break;
			}
		else
			testfail=1;

		if (testfail)
		{
			IK_PRINTF ("\tBme %d: ****** AFE-%d register write/read test FAILED\n\n", bmeNum, afe);
		}
		else
		{
			IK_PRINTF ("\tBme %d: AFE-%d register write/read test PASSED\n\n", bmeNum, afe);
		}
	}
	return testfail;
}
//-----------------------------------------------------------
int bup_afe_all_reg_rw (int bmeNum, int afenum) {
	int i,j = 0;
	int testfail = 0;
	UINT32 ReadData;
//  int afenum;

	UINT32 RegAddr [32] = { 0x24, 0x20, 0x21, 0x25, 0x29, 0x2d, 0x30, 0x31,
		0x32, 0x33, 0x34, 0x36, 0x3f, 0x70, 0x71, 0x72,
		0x73, 0x78, 0x7a, 0x7c, 0x86, 0x88, 0x8a, 0x90,
		0x91, 0x92, 0x93 ,0x94, 0xa0, 0xa2, 0xa8, 0xf0};

	UINT32 Regwdat [32] = { 0x1,  0x1,  0x1,  0x1,  0x1,  0x200, 0x8000, 0,
		0,    0,    0x1,  0x1,  0,    0x1,   0x1,    0,
		0,    0x1,  0x1,  0x1,  0x100, 0x1,  0x1,    0x1,
		0x1,  0x1,  0x1,  0x1,  0,    0,     0x1,    0x1};

	UINT32 RegDef [32] = {  0x00000000, 0x00000000, 0x00000000, 0x00000000, 
		0x00000000, 0x00000200, 0x0000c000, 0x00000000, 
		0x00000000, 0x00000000, 0x00000000, 0x00000000, 
		0x00000910, 0x00000000, 0x00000000, 0x00000010, 
		0x00000010, 0x00000000, 0x00000000, 0x00007fff, 
		0x0000700c, 0x0000300c, 0x00000001, 0x00000000, 
		0x00000000, 0x00000000, 0x00000000, 0x00000000, 
		0x00000000, 0x00000000, 0x00000000, 0x003001d0};

//  DBG2(("Enter the AFE number:"))
//  scanf ("%d", &afenum);
//  DBG2(("%d\n", afenum))
//  DBG2( ("\n"));

	bup_Enable_Vbus (bmeNum,afenum/2);

	//checking defaule value
	//DBG2( ("\t***** Reading default (reset) values of all registers\n"));
	for (i=0; i<32; i++)
	{
		if ((RegAddr[i] == 0x32) || (RegAddr[i] == 0x73))
			i++;
		else
		{
			ReadData = bup_rdAfeReg (bmeNum, afenum, RegAddr[i]);

			if (ReadData != RegDef[i])
			{
//				DBG0(("Bme %d: AFE register 0x%x reset value WRONG: Expected: 0x%x, Actual: 0x%x\n", bmeNum,RegAddr[i], RegDef[i], ReadData));
				testfail = 1;
				j++;
			}
		}
	}

	//writing registers
	//DBG2( ("\t***** Writing all registers\n"));
	for (i=0; i<32; i++)
	{
		if ((RegAddr[i] != 0x31) && (RegAddr[i] != 0x32) && (RegAddr[i] != 0x33) &&
			(RegAddr[i] != 0x3f) && (RegAddr[i] != 0x72) && (RegAddr[i] != 0x73) &&
			(RegAddr[i] != 0xa0) && (RegAddr[i] != 0xa2))	// read only regs
			bup_wtAfeReg (bmeNum, afenum, RegAddr[i], Regwdat[i]);
	}

	//reading registers
	//DBG2( ("\t***** Reading and comparing all registers\n"));
	for (i=0; i<32; i++)
	{
		if ((RegAddr[i] != 0x31) && (RegAddr[i] != 0x32) && (RegAddr[i] != 0x33) &&
			(RegAddr[i] != 0x3f) && (RegAddr[i] != 0x72) && (RegAddr[i] != 0x73) &&
			(RegAddr[i] != 0xa0) && (RegAddr[i] != 0xa2) && (RegAddr[i] != 0x25) &&
			(RegAddr[i] != 0x91) && (RegAddr[i] != 0x24))
		{	// read is invalid on these
			ReadData = bup_rdAfeReg (bmeNum, afenum, RegAddr[i]);
			if (ReadData != Regwdat[i])
			{
//				DBG0(("Bme %d: Register 0x%x write/read FAILED, ReadData:0x%x ExpData:0x%x\n", bmeNum, RegAddr[i], ReadData, Regwdat[i]))
				testfail = 1;
				j++;
			}
		}
	}

	if (testfail)
	{
		DBG0(("***********************************************************\n"))
		DBG0(("\tBme %d: AFE-%d All registers r/w test FAILED for %d registers\n",bmeNum, afenum,j))
		DBG0(("***********************************************************\n"))
	}
	else
	{
		DBG2(("\tBme %d: AFE-%d All registers r/w test PASSED !\n",bmeNum, afenum))
	}
	return testfail;
}
//----------------------------------------------------------------------------------
void bup_afe_all_reg_rw_loop (int bmeNum, int loopcnt) {
	int i, j, testfail;

	for (i=0; i<loopcnt; i++)
	{
		DBG2(("%d  ", i))
		for (j=0; j<8; j++)
		{
			testfail = bup_afe_all_reg_rw(bmeNum, j);
			if (testfail)
				break;
			else
				bmeHWReset ();
			iposTaskDelay (50);
		}
	}
}

int bup_read_ife_id (int bmeNum) 
{
	int data;
	int i;

	bup_Enable_Vbus (bmeNum,0);
	bup_Enable_Vbus (bmeNum,1);
	bup_Enable_Vbus (bmeNum,2);
	bup_Enable_Vbus (bmeNum,3);

	for (i = 0;i < 4;i++)
	{
		data = bup_rdAfeReg (bmeNum, i,0x21);
		data = bup_rdAfeReg (bmeNum, i,0x21);
		data &= 0xffff;
		if (data == 0x2400)
		{

			DBG2(("Bme %d: IFE Recognized. IFE %d = %x\n",bmeNum, i, data))
		}
		else
			DBG0(("Bme %d: IFE Not Recognized. IFE %d = %x\n",bmeNum, i, data))

	}
	return 0;
}

int bup_testIfe (int bmeNum, int j)
{
	int data, stat;
	int i = 0;

	bup_Enable_Vbus (bmeNum,j/2);

	bup_wtAfeReg(bmeNum, j, 0x20, 0x09040000 + (j*0x10000));
	data = bup_rdAfeReg (bmeNum, j,0x20);
	while (i++<100)
	{
		stat = bup_rdAfeReg (bmeNum, j,0x24);
		if (stat & 2) break;
	}
	data = bup_rdAfeReg (bmeNum, j,0x20);
	if ((data&0xffff0000) == 0x09040000 + (j*0x10000))
	{
		DBG2(("Bme %d: IFE Read/Write passed. IFE %d = %x\n",bmeNum, j, data))
		stat = 0;
	}
	else
	{
		DBG0(("******* Bme %d: IFE Read/Write Failed. IFE %d = %x\n",bmeNum, j, data))
		stat = ERROR;
	}
	return stat;

}


/*********************************************************/
/*              LOCAL FUNCTION DEFINITIONS               */
/*********************************************************/

//---------------------------------------------------------------
void bup_Enable_Vbus (int bmeNum, int vbusnum) {
	testPIOWrite (bmeNum,0xe0018000+(vbusnum*0x2000),0x80000000);
//	DBG2( (" Vbus-%d Enabled !!!\n", vbusnum));
}
//---------------------------------------------------------------
UINT32 bup_rdAfeReg (int bmeNum, int afenum, UINT32 addr) {
	UINT32 ad, dat;
	int i = 0;

	ad  = 0xe0018008 + (afenum/2 * 0x2000);
	dat = 0x80000000 + ((afenum&0x1)<<8) + addr;

	testPIOWrite( bmeNum, ad, dat);
	ad  = 0xe0018014 + (afenum/2 * 0x2000);
	dat = testPIORead1 (bmeNum, ad);
	i   = 0;
	while ((dat & 0x80000000) ==0 )
	{
		dat = testPIORead1(bmeNum, ad);
		i++;
		if (i > 200 )
		{
			DBG0(("Bme %d: ERROR : TimedOUT for ReadDone bit\n", bmeNum))
			break;
		}
	}
	ad  = 0xe001800c + (afenum/2 * 0x2000);
	dat = testPIORead1(bmeNum, ad);
	return dat;
}
//---------------------------------------------------------------
int bup_rdnchkAfeReg(int bmeNum, int afenum, UINT32 addr, UINT32 exp_data) {
	UINT32 dat;

	dat = bup_rdAfeReg (bmeNum, afenum, addr);
	if (dat == exp_data)
		return 0;
	else
	{
		DBG0(("Bme %d: AFE register 0x%x mismatch- expected: 0x%x, actual: 0x%x\n", bmeNum, addr, exp_data, dat))
		return 1;
	}
}

//---------------------------------------------------------------
void bup_wtAfeReg (int bmeNum, int afenum, UINT32 addr, UINT32 data) {
	UINT32 ad, dat;
	int i = 0;

	ad = 0xe0018014 + (afenum/2 * 0x2000);
	dat = testPIORead1 (bmeNum, ad);
	while ((dat & 0x40000000) !=0 )
	{
		dat = testPIORead1(bmeNum, ad);
		i++;
		if (i > 200 )
		{
			DBG0(("Bme %d: ERROR : Command Queue is Full \n", bmeNum))
			break;
		}
	}

	ad = 0xe0018010 + (afenum/2 * 0x2000);
	testPIOWrite(bmeNum, ad, data);
	ad = 0xe0018008 + (afenum/2 * 0x2000);
	dat = 0x40000000 + ((afenum&0x1)<<8) + addr;
	testPIOWrite(bmeNum, ad, dat);
}
//---------------------------------------------------------------
int bup_chk_afeid (int bmeNum, int afenum) {
	UINT32 AfeId;

	AfeId = bup_rdAfeReg (bmeNum, afenum, 0x3f);
	AfeId = AfeId & 0xfff;
	DBG2(("\n"))
	if ((AfeId == 0x810) || (AfeId == 0x820))
	{
		DBG2(("\tBme %d: AFE on board is AFE-LS\n", bmeNum))
		return 1;
	}
	else if (AfeId == 0x910)
	{
		DBG2(("\tBme %d: AFE %d is AFE-BRONCO\n", bmeNum, afenum))
		return 2;
	}
	else
	{
		DBG0(("Bme %d:   >>>> No/Bad AFE #%d on board <<<< \n",bmeNum, afenum))
		return 0;
	}
}
//---------------------------------------------------------------
#endif //!CO_30




