#include <stdio.h>
#include "dapi.h"
#include "ipos.h"
//#include "bsp.h"

extern void HostFpgaWrite(BYTE boffset,BYTE bdata);
extern void bmeHwResetApi (int BmeNum);
extern void tpw (int BmeNum, unsigned long addr, unsigned long data);
extern int testPIORead (int BmeNum, unsigned long addr);

void reload_aztec () 
{
  printf("Reloading Aztec FPGA .....\n");
  HostFpgaWrite (0xc,0xc1); 
  printf("Reload DONE .....\n");
}
/*--------------------------------------------------*/

void reset_aztec ()
{
  printf("Resetting Aztec FPGA .....\n");
  bmeHwResetApi (1); 
  printf("Reset DONE .....\n");
}
/*--------------------------------------------------*/

void config_uart1 ()
{
  tpw (1, 0xe00a000c,0x83); /* set DLAB bit             */
  tpw (1, 0xe00a0000,0xe4); /* set divisor low bit      */
  tpw (1, 0xe00a0004,0x00); /* set divisor hi bit       */
  tpw (1, 0xe00a000c,0x1b); /* set clear DLAB bit       */
  tpw (1, 0xe00a0008,0x01); /* set fifo enable bit      */
  tpw (1, 0xe00a0004,0x01); /* set interrupt enable bit */
}

void config_uart2 ()
{
  tpw (1, 0xe00a200c,0x83); /* set DLAB bit             */
  tpw (1, 0xe00a2000,0xe4); /* set divisor low bit      */
  tpw (1, 0xe00a2004,0x00); /* set divisor hi bit       */
  tpw (1, 0xe00a200c,0x1b); /* set clear DLAB bit       */
  tpw (1, 0xe00a2008,0x01); /* set fifo enable bit      */
  tpw (1, 0xe00a2004,0x01); /* set interrupt enable bit */
}
/*--------------------------------------------------*/
void send_message_uart1 ()
{ 
  char *pString = "\nWelcome to Ikanos Communications*";
  UINT32 uartdata;
  
  while(*pString != '*')
  {
    uartdata = *pString;
//    uartdata <<= 24;
    tpw (1, 0xe00a0000,uartdata);
    iposTaskDelay(30);
//    printf ("%x  ", uartdata);
    pString++;
  }
}

/*--------------------------------------------------*/
void send_message_uart2 ()
{ 
  char *pString = " Welcome to Ikanos Communications*";
  UINT32 uartdata;
  
  while(*pString != '*')
  {
    uartdata = *pString;
    uartdata <<= 24;
    printf ("%x  ", (int) uartdata);
    pString++;
  }
}

//---------------------------------------------
void regression_uart1 ()
{
  int i;
  for (i = 0; i< 1000; i++)
    {
	send_message_uart1();
    }
}
//---------------------------------------------
void receive_char ()
{
  UINT32 intr_status;
  UINT32 break_first_while;
  UINT32 i;
  UINT32 rcvd_char;
  UINT32 data;

  i = 0;
  break_first_while = 0;
  printf("\n Receive Characters........\n");

  while (1)
  {
  	intr_status = testPIORead (1,0xe00a0008);
  	while (!(intr_status & 0x04000000))
        {
         if (i ==500)
         {
	    i = 0;
	    break_first_while = 1;
	    printf("\n****** character timeout ******\n");
	    break;
	  }
          intr_status = testPIORead (1,0xe00a0008);
          i++;
          iposTaskDelay(30);		/* TT ID 1205 */
        }
	if (break_first_while)
	  {
		break;
	  }
	else
	  {
  		rcvd_char = testPIORead (1,0xe00a0000);
		data = (UINT32)rcvd_char & 0xff000000;
		data >>= 24;
		printf ("%c", (U8) data);
	  }
    }
}
//-------------------------------------------------------
void init_sdram_32clk ()
{
  tpw (1,0xe0038000,0x0000017b);
  tpw (1,0xe0038004,0x000000ee);
  
//  tpw (1,0xe0038004,0x00000077);
  tpw (1,0xe003800c,0x00000000);
  tpw (1,0xe0038008,0x00000000);
  tpw (1,0xe0038008,0x00000000);
  tpw (1,0xe0038010,0x00000000);
}
//-------------------------------------------------------
void init_sdram_32clkby2 ()
{
  tpw (1,0xe0038000,0x0000002d); 
  tpw (1,0xe0038004,0x000000ee);
  tpw (1,0xe003800c,0x00000000);
  tpw (1,0xe0038008,0x00000000);
  tpw (1,0xe0038008,0x00000000);
  tpw (1,0xe0038010,0x00000000);
}
//-------------------------------------------------------
void init_sdram_16clk () 
{ 
#ifdef CPE_30 
  tpw (1,0xe0038000,0x0000037d); // Module control register 
  tpw (1,0xe0038004,0x00000500); // Refresh period 
  tpw (1,0xe003800c,0x00000000); // Precharge cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038008,0x00000000); // Refresh cmd 
  tpw (1,0xe0038010,0x00000000); // Set mode cmd 
  tpw (1,0xe0038008,0x00000000); // Precharge cmd 
#else 
  tpw (1,0xe0038000,0x0000032d); 
  tpw (1,0xe0038004,0x000000ee); 
  tpw (1,0xe003800c,0x00000000); 
  tpw (1,0xe0038008,0x00000000); 
  tpw (1,0xe0038008,0x00000000); 
  tpw (1,0xe0038010,0x00000000); 
#endif 
} 

//-------------------------------------------------------
void init_sdram_16clkby2 ()
{
  tpw (1,0xe0038000,0x0000022d); 
  tpw (1,0xe0038004,0x000000ee);
  tpw (1,0xe003800c,0x00000000);
  tpw (1,0xe0038008,0x00000000);
  tpw (1,0xe0038008,0x00000000);
  tpw (1,0xe0038010,0x00000000);
}
//-------------------------------------------------------
void write_sdram (int StartAddr, int NumLocations, UINT32 StartData)
{
  UINT32 SdramAddr;
  UINT32 data;
  int SdramMaxAddr;
  int i;

  data = StartData;
  SdramMaxAddr = StartAddr + ( NumLocations * 4); //max 16777216 for 16 Mbyte memory
  for (i=StartAddr; i<SdramMaxAddr; i=i+4)
    {
	SdramAddr = i & 0xffffffff;
	tpw (1,SdramAddr,data);
	printf ("SDRAM Address : 0x%x\t WriteData : 0x%x\n",(int) SdramAddr, (int) data);
	data++;
    }
}
//-------------------------------------------------------
void read_sdram (int StartAddr, int NumLocations, UINT32 StartData)
{
  UINT32 SdramAddr;
  UINT32 data,ExpData;
  int SdramMaxAddr;
  int i;
  int flag = 0;

  data = 0xbad;
  ExpData = StartData;
  SdramMaxAddr = StartAddr + (NumLocations * 4); //max 16777216 for 16 Mbyte memory
  for (i=StartAddr; i<SdramMaxAddr; i=i+4)
    {
	SdramAddr = i & 0xffffffff;
	data = testPIORead (1,SdramAddr);
	if (data != ExpData)
	  {
	    flag = 1;
	    printf ("SDRAM Data mismatch @Addr :0x%x  ReadData:0x%x ExpectedData:0x%x\n",(int) SdramAddr, (int) data, (int) ExpData);
	  }
	else
	  {
	    printf ("SDRAM Data correct  @Addr :0x%x  ReadData:0x%x ExpectedData:0x%x\n",(int) SdramAddr, (int) data, (int) ExpData);
	  }
	ExpData++;
    }
  if (!flag)
    {
      printf ("SDRAM Data read/compare OK .........\n");
    }
  else
    {
      printf ("SDRAM Data compare ERROR .........\n");
    }
}
//--------------------------------------------------------
void sdram_dma (UINT32 StartData)
{
  int i = 0;
  UINT32 data1 = 0x0;

  write_sdram (0x40000000, 25, StartData);  //write SDRAM 100 locations
   
  tpw (1,0xe0030040,0x80000000);  //set software DMA request
  tpw (1,0xe0030080,0x40000000);  //set source address
  tpw (1,0xe00300c0,0xca000000);  //set dest address
  tpw (1,0xe0030000,0x00631001);  //Load DMA ccr register to start DMA
  iposTaskDelay(10);		  /* TT ID 1205 */
  while (!(data1 & 0x100))  //polling for DMA done bit
    {
	iposTaskDelay(10);	  /* TT ID 1205 */
	data1 = testPIORead (1,0xe0030000);
	i++;
	if (i == 300)
	  {
	    i = 0;
	    printf ("********* Time out in DMA done polling1 ********\n");
	    break;
	  }
    }

  tpw (1,0xe0030000,0x0);  //clear ccr
  tpw (1,0xe0030040,0x80000000);  //set DMA ECR register
  tpw (1,0xe0030080,0xca000000);  //set source address
  tpw (1,0xe00300c0,0x400000f0);  //set dest address
  tpw (1,0xe0030000,0x00631001);  //Load DMA ccr register to start DMA

  data1 = 0x0;
  while (!(data1 & 0x100))  //polling for DMA done bit
    {
	iposTaskDelay(10);	  /* TT ID 1205 */
	data1 = testPIORead (1,0xe0030000);
	i++;
	if (i == 300)
	  {
	    i = 0;
	    printf ("********* Time out in DMA done polling2 ********\n");
	    break;
	  }
    }

  read_sdram (0x400000f0,25,StartData);
}
//--------------------------------------------------------------
void erase_sector_amd_flash (UINT32 SectAddr)
{
   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x0000aa00);

   tpw (1,0xe00a6004,0x84000000);
   tpw (1,0x80000554,0x00550000);

   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x00008000);

   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x0000aa00);

   tpw (1,0xe00a6004,0x84000000);
   tpw (1,0x80000554,0x00550000);

   tpw (1,0xe00a6004,0x88000000);
   tpw (1,SectAddr,0x30000000);
}

//--------------------------------------------------------------
void write_read_amd_flash ()
{
   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x0000aa00);

   tpw (1,0xe00a6004,0x84000000);
   tpw (1,0x80000554,0x00550000);

   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x0000a000);

   tpw (1,0xe00a6004,0x88000000);
   tpw (1,0x80020000,0x22222222);

   testPIORead (1,0x80020000);
}

//--------------------------------------------------------------
void read_mid_amd_flash ()
{
   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x0000aa00);

   tpw (1,0xe00a6004,0x84000000);
   tpw (1,0x80000554,0x00550000);

   tpw (1,0xe00a6004,0x82000000);
   tpw (1,0x80000aa8,0x00009000);

   tpw (1,0xe00a6004,0x88000000);
   //tpw (1,0x80000000,0x22222222);

   testPIORead (1,0x80000000);
}

//--------------------------------------------------------------
void chk_reg (UINT32 addr, UINT32 exp_data)
{
  UINT32 read_data;
  read_data = 0x00000000;

  read_data = testPIORead (1,addr);
  if (read_data == exp_data)
    {
      printf ("Aztec register 0x%x programmed correctly to 0x%x\n",(int) addr,(int) read_data);
    }
  else
    {
      printf ("ERROR in Aztec register 0x%x programming, Read data:0x%x  Expected data:0x%x\n",(int) addr, (int) read_data,(int) exp_data);
    }
}

//--------------------------------------------------------------
void config_netif (UINT32 PREAMBLE, UINT32 DUPLEX, UINT32 FC, UINT32 SPEED)
// PREAMBLE[2:0] : minumum bytes of preamble
// DUPLEX : 0 - full, 1 - half
// FC[1:0] : 00 - No flow control, 01 - full duplex (pause fr), 10 - HD (CRS)
// SPEED : 0 - 10 Mbps, 1 - 100 Mbps
{
UINT32 xpcr = 0x7801 | (PREAMBLE << 8) | (DUPLEX << 4) | (FC << 2) | (SPEED << 1);
   tpw (1,0xe0098344,0x00000001);  //utopia config register
   tpw (1,0xe0098300,0x00000000);  //utopia poll register
   tpw (1,0xe0098340,0x00000001);  //utopia phys active
   tpw (1,0xe00988a0,0x00000000);  //DBGR
//   tpw (1,0xe0098880,0x00007f03);  //XPCR
   tpw (1,0xe0098880,xpcr);  //XPCR
   tpw (1,0xe00988d0,0x0000019a);  //XSCR
   tpw (1,0xe00988c8,0x00000040);  //MIFSR
   tpw (1,0xe00988cc,0x00000600);  //MAFSR
   tpw (1,0xe00988c0,0x000003ff);  //THAFR
   tpw (1,0xe0098904,0x00000000);  //TFWPR
   tpw (1,0xe0098900,0x00000000);  //TFRPR
   tpw (1,0xe0098890,0x00001060);  //TFCR1
   tpw (1,0xe009890c,0x00000000);  //RFWPR
   tpw (1,0xe0098908,0x00000000);  //RFRPR
   tpw (1,0xe0098898,0x00000060);  //RFCR1
   tpw (1,0xe00988d4,0x00000001);  //PFSAR
   tpw (1,0xe00988d8,0x00009528);  //PFCR0
   tpw (1,0xe00988dc,0x00004e20);  //PFCR1
   tpw (1,0xe00988e0,0x00004309);  //RFCRR0
   tpw (1,0xe00988e4,0x0000d0d0);  //RFCRR1
   tpw (1,0xe0098894,0x00000089);  //RFCR0
   tpw (1,0xe009888c,0x00000081);  //TFCR0

   chk_reg (0xe0098344,0x00000001);  //utopia config register
   chk_reg (0xe0098300,0x00000000);  //utopia poll register
   chk_reg (0xe0098340,0x00000001);  //utopia phys active
   chk_reg (0xe00988a0,0x00000000);  //DBGR
   chk_reg (0xe0098880,xpcr);  //XPCR
   chk_reg (0xe00988d0,0x0000019a);  //XSCR
   chk_reg (0xe00988c8,0x00000040);  //MIFSR
   chk_reg (0xe00988cc,0x00000600);  //MAFSR
   chk_reg (0xe00988c0,0x000003ff);  //THAFR
   chk_reg (0xe0098904,0x00000000);  //TFWPR
   chk_reg (0xe0098900,0x00000000);  //TFRPR
   chk_reg (0xe009888c,0x00000081);  //TFCR0
   chk_reg (0xe0098890,0x00001060);  //TFCR1
   chk_reg (0xe009890c,0x00000000);  //RFWPR
   chk_reg (0xe0098908,0x00000000);  //RFRPR
   chk_reg (0xe0098894,0x00000089);  //RFCR0
   chk_reg (0xe0098898,0x00000060);  //RFCR1
   chk_reg (0xe00988d4,0x00000001);  //PFSAR
   chk_reg (0xe00988d8,0x00009528);  //PFCR0
   chk_reg (0xe00988dc,0x00004e20);  //PFCR1
   chk_reg (0xe00988e0,0x00004309);  //RFCRR0
   chk_reg (0xe00988e4,0x0000d0d0);  //RFCRR1
}



void	initGpio (void)
{
	HostFpgaWrite(4,0xff);
	tpw (1,0xe00a6004,0xff);
}


void	initDbgBus()
{

}















