/**************************************************************
***************************************************************
**
** C-SIMULATION, Copyright (C) 2002-2004
** Ikanos Communication, Fremont, CA 
** All rights reserved.
**
** The information and contents of this file are the
** proprietary information of Ikanos Communication and may not
** be disclosed or used without the formal written approval of 
** Ikanos Communication
**
***************************************************************

$Revision: 1.1 $
$Date: 2006/10/16 04:34:51 $
**************************************************************/

/*******  Include Files         ***************************************/
#include <stdio.h>
#ifdef USE_VXWORKS /* IXDP425 */
#include <ioLib.h>
#include <tickLib.h>
#else
#include <sys/ioctl.h>
#include <sys/types.h>
#include <fcntl.h>
#include "apposmacro.h"
#define UINT unsigned int
#endif
#include "consoleUtil.h"

/*******  Defines               ***************************************/
#define STATIC  static

/*******  Constants             ***************************************/

/*******  Local Data Structures ***************************************/

/*******  External Functions    ***************************************/
//extern int sysClkRateGet(void); /* IXDP425 */

/*******  Global Data           ***************************************/
#ifdef USE_VXWORKS /* IXDP425 */
extern int consoleFd;
#else
int consoleFd;
#endif

/*******  Local Data            ***************************************/    

/*******  Local Functions Prototypes **********************************/

/*
************************************************************************
    Function: 
    
    Description: 
    
    Return Value: void
************************************************************************
*/
void consoleEchoDisable(void)
{
#ifdef USE_VXWORKS /* IXDP425 */
  ioctl (consoleFd, FIOSETOPTIONS, OPT_TERMINAL & ~OPT_ECHO);
#endif
}

/*
************************************************************************
    Function: 
    
    Description: 
    
    Return Value: void
************************************************************************
*/
void consoleEchoEnable(void)
{
#ifdef USE_VXWORKS /* IXDP425 */
  ioctl (consoleFd, FIOSETOPTIONS, OPT_TERMINAL);
#endif
}

/*
************************************************************************
    Function: 
    
    Description: 
    
    Return Value: void
************************************************************************
*/
int consoleKbHit (unsigned int timeout /* timeout time in seconds */)
{
  UINT  timeMarker;
  int       bytesRead;
#ifndef USE_VXWORKS /* IXDP425 */
  consoleFd = open("/dev/console",O_RDONLY);
#endif
  ioctl (consoleFd, FIONREAD, (int) &bytesRead);
  if (timeout > 0)
    {
	  printf ("\nPress enter key to stop auto startup...\n");
      /* Loop looking for a char, or timeout after specified seconds */                  
	  timeMarker = iposTickGet () + sysClkRateGet (); /* IXDP425 */

	  printf ("%2d\n", timeout);

      while ((timeout > 0) && (bytesRead == 0))
      {
        (void) ioctl (consoleFd, FIONREAD, (int) &bytesRead);

	    if (iposTickGet () >= timeMarker) /* IXDP425 */
          {
		    timeMarker = iposTickGet () + sysClkRateGet (); /* IXDP425 */
		    printf ("%2d\n", --timeout);
          }
      }
    }
#ifndef USE_VXWORKS /* IXDP425 */
  close(consoleFd);
#endif
  return (bytesRead);
}

